package com.bjtdba.order.dao;

import com.bjtdba.entity.order.Recommend;
import com.bjtdba.order.vo.CategoryVo;
import com.bjtdba.order.vo.RecommendDetailVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * (Recommend)表数据库访问层
 *
 * @author makejava
 * @since 2022-10-19 13:24:00
 */
@Repository
@Mapper
public interface RecommendDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    Recommend queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param recommend 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<Recommend> queryAllByLimit(Recommend recommend);

    /**
     * 统计总行数
     *
     * @param recommend 查询条件
     * @return 总行数
     */
    long count(Recommend recommend);

    /**
     * 新增数据
     *
     * @param recommend 实例对象
     * @return 影响行数
     */
    int insert(Recommend recommend);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<Recommend> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<Recommend> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<Recommend> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<Recommend> entities);

    /**
     * 修改数据
     *
     * @param recommend 实例对象
     * @return 影响行数
     */
    int update(Recommend recommend);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 查询小于等于当前的前10条日期
     * @return
     */
    List<Date> queryShowTime();

    /**
     * 查询大仓商品详细信息
     * @return
     */
    RecommendDetailVo queryDetail(Integer id);

    /**
     * 大仓分类
     */
    List<CategoryVo> queryCategorylist();

    /**
     * 大仓推荐分享
     * @param id
     * @return
     */
    Map<String,String> queryByIdShare(Integer id);


    /**
     * 店铺分类
     */
    List<CategoryVo>  queryCategorylistMerid(Integer merid);

}

